/* Andrey N. Kuznetsov, Almaty, 2012 *
 * For educational purposes.         *
 * Under GPL 2.0                     */
//---------------------------------------------------------------------
#include "TCentralComponent.h"
//---------------------------------------------------------------------
#define tr(s) String::fromUTF8(s)
//---------------------------------------------------------------------
TCentralComponent::TCentralComponent() : Component ("Central Component"),
                                         pTextButton(0),
                                         pTextEdit(0)
{
    pTextButton = new TextButton("Text Button");
    pTextButton->addListener(this);
    pTextButton->setButtonText(tr("Введи новый текст и нажми кнопку"));
    addAndMakeVisible(pTextButton);

    pTextEdit = new TextEditor("Text Editor");
    pTextEdit->setReturnKeyStartsNewLine(false);
    pTextEdit->setText(String::empty);
    addAndMakeVisible(pTextEdit);

    setSize (400, 150);
}
//---------------------------------------------------------------------
TCentralComponent::~TCentralComponent()
{
    // Удаляем дочерние виджеты
    // и обнуляем их указатели
    deleteAllChildren();
}
//---------------------------------------------------------------------
void TCentralComponent::paint(Graphics& Canvas)
{
    Canvas.fillAll(Colours::azure);
}
//---------------------------------------------------------------------
void TCentralComponent::resized()
{
    // Задаём стартовые размеры кнопки
    pTextButton->setBounds(20, 16, 240, 25);
    // "Подгоняет" размеры кнопки под отображаемую надпись
    pTextButton->changeWidthToFitText(-1);
    pTextEdit->setBounds(20, 56, getWidth() - 40, 25);
}
//---------------------------------------------------------------------
void TCentralComponent::buttonClicked(Button* pButton)
{
    // Если нажата кнопка...
    if(pButton == pTextButton)
    {
        if(!pTextEdit->getText().containsNonWhitespaceChars()) return;
        // в качестве надписи устанавливаем
        // текст из поля ввода
        pTextButton->setButtonText(pTextEdit->getText());
        // "Подгоняет" размеры кнопки под отображаемую надпись
        pTextButton->changeWidthToFitText(-1);
    }
}
//---------------------------------------------------------------------

